// -------------------------------------------------------------
//
// Module: CIC_R100_M1_N10
//
// Generated by MATLAB(R) 7.2 and the Filter Design HDL Coder 1.4.
//
// Generated on: 2006-09-07 16:59:32
//
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// TargetLanguage: Verilog
// Name: CIC_R100_M1_N10
// TargetDirectory: c:\data
// FIRAdderStyle: tree
// CoeffMultipliers: csd
// SerialPartition: -1
// AddPipelineRegisters: On
// CastBeforeSum: On
//
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure         : Cascaded Integrator-Comb Decimator
// Decimation Factor        : 100
// Differential Delay       : 1
// Number of Sections       : 10
// Stable                   : Yes
// Linear Phase             : No
//
// Input                    : s16,0
// Output                   : s18,-65
// Filter Internals         : Minimum Word Lengths
//   Integrator Section 1   : s64,-19
//   Integrator Section 2   : s64,-19
//   Integrator Section 3   : s64,-19
//   Integrator Section 4   : s64,-19
//   Integrator Section 5   : s64,-19
//   Integrator Section 6   : s63,-20
//   Integrator Section 7   : s47,-36
//   Integrator Section 8   : s42,-41
//   Integrator Section 9   : s37,-46
//   Integrator Section 10  : s32,-51
//   Comb Section 1         : s29,-54
//   Comb Section 2         : s28,-55
//   Comb Section 3         : s27,-56
//   Comb Section 4         : s27,-56
//   Comb Section 5         : s26,-57
//   Comb Section 6         : s25,-58
//   Comb Section 7         : s24,-59
//   Comb Section 8         : s23,-60
//   Comb Section 9         : s22,-61
//   Comb Section 10        : s21,-62
//
// Implementation Cost
// Number of Multipliers : 0
// Number of Adders      : 20
// Number of States      : 20
// MultPerInputSample    : 0
// AddPerInputSample     : 10.1
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module CIC_R100_M1_N10 
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [15:0] filter_in; //sfix16
  output  signed [17:0] filter_out; //sfix18_E65
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: CIC_R100_M1_N10
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  // Signals
  reg  [6:0] cur_count; // ufix7
  wire phase_1; // boolean
  wire ce_delayline; // boolean
  reg  int_delay_pipe [0:8] ; // boolean
  wire ce_gated; // boolean
  reg  ce_out_reg; // boolean
  //   
  reg  signed [15:0] input_register; // sfix16
  //   -- Section 1 Signals 
  wire signed [15:0] section_in1; // sfix16
  wire signed [63:0] section_cast1; // sfix64_E19
  wire signed [63:0] sum1; // sfix64_E19
  reg  signed [63:0] section_out1; // sfix64_E19
  wire signed [63:0] add_cast; // sfix64_E19
  wire signed [63:0] add_cast_1; // sfix64_E19
  wire signed [64:0] add_temp; // sfix65_E19
  //   -- Section 2 Signals 
  wire signed [63:0] section_in2; // sfix64_E19
  wire signed [63:0] sum2; // sfix64_E19
  reg  signed [63:0] section_out2; // sfix64_E19
  wire signed [63:0] add_cast_2; // sfix64_E19
  wire signed [63:0] add_cast_3; // sfix64_E19
  wire signed [64:0] add_temp_1; // sfix65_E19
  //   -- Section 3 Signals 
  wire signed [63:0] section_in3; // sfix64_E19
  wire signed [63:0] sum3; // sfix64_E19
  reg  signed [63:0] section_out3; // sfix64_E19
  wire signed [63:0] add_cast_4; // sfix64_E19
  wire signed [63:0] add_cast_5; // sfix64_E19
  wire signed [64:0] add_temp_2; // sfix65_E19
  //   -- Section 4 Signals 
  wire signed [63:0] section_in4; // sfix64_E19
  wire signed [63:0] sum4; // sfix64_E19
  reg  signed [63:0] section_out4; // sfix64_E19
  wire signed [63:0] add_cast_6; // sfix64_E19
  wire signed [63:0] add_cast_7; // sfix64_E19
  wire signed [64:0] add_temp_3; // sfix65_E19
  //   -- Section 5 Signals 
  wire signed [63:0] section_in5; // sfix64_E19
  wire signed [63:0] sum5; // sfix64_E19
  reg  signed [63:0] section_out5; // sfix64_E19
  wire signed [63:0] add_cast_8; // sfix64_E19
  wire signed [63:0] add_cast_9; // sfix64_E19
  wire signed [64:0] add_temp_4; // sfix65_E19
  //   -- Section 6 Signals 
  wire signed [63:0] section_in6; // sfix64_E19
  wire signed [62:0] section_cast6; // sfix63_E20
  wire signed [62:0] sum6; // sfix63_E20
  reg  signed [62:0] section_out6; // sfix63_E20
  wire signed [62:0] add_cast_10; // sfix63_E20
  wire signed [62:0] add_cast_11; // sfix63_E20
  wire signed [63:0] add_temp_5; // sfix64_E20
  //   -- Section 7 Signals 
  wire signed [62:0] section_in7; // sfix63_E20
  wire signed [46:0] section_cast7; // sfix47_E36
  wire signed [46:0] sum7; // sfix47_E36
  reg  signed [46:0] section_out7; // sfix47_E36
  wire signed [46:0] add_cast_12; // sfix47_E36
  wire signed [46:0] add_cast_13; // sfix47_E36
  wire signed [47:0] add_temp_6; // sfix48_E36
  //   -- Section 8 Signals 
  wire signed [46:0] section_in8; // sfix47_E36
  wire signed [41:0] section_cast8; // sfix42_E41
  wire signed [41:0] sum8; // sfix42_E41
  reg  signed [41:0] section_out8; // sfix42_E41
  wire signed [41:0] add_cast_14; // sfix42_E41
  wire signed [41:0] add_cast_15; // sfix42_E41
  wire signed [42:0] add_temp_7; // sfix43_E41
  //   -- Section 9 Signals 
  wire signed [41:0] section_in9; // sfix42_E41
  wire signed [36:0] section_cast9; // sfix37_E46
  wire signed [36:0] sum9; // sfix37_E46
  reg  signed [36:0] section_out9; // sfix37_E46
  wire signed [36:0] add_cast_16; // sfix37_E46
  wire signed [36:0] add_cast_17; // sfix37_E46
  wire signed [37:0] add_temp_8; // sfix38_E46
  //   -- Section 10 Signals 
  wire signed [36:0] section_in10; // sfix37_E46
  wire signed [31:0] section_cast10; // sfix32_E51
  wire signed [31:0] sum10; // sfix32_E51
  reg  signed [31:0] section_out10; // sfix32_E51
  wire signed [31:0] add_cast_18; // sfix32_E51
  wire signed [31:0] add_cast_19; // sfix32_E51
  wire signed [32:0] add_temp_9; // sfix33_E51
  //   -- Section 11 Signals 
  wire signed [31:0] section_in11; // sfix32_E51
  wire signed [28:0] section_cast11; // sfix29_E54
  reg  signed [28:0] diff1; // sfix29_E54
  wire signed [28:0] section_out11; // sfix29_E54
  wire signed [28:0] sub_cast; // sfix29_E54
  wire signed [28:0] sub_cast_1; // sfix29_E54
  wire signed [29:0] sub_temp; // sfix30_E54
  reg  signed [28:0] cic_pipeline11; // sfix29_E54
  //   -- Section 12 Signals 
  wire signed [28:0] section_in12; // sfix29_E54
  wire signed [27:0] section_cast12; // sfix28_E55
  reg  signed [27:0] diff2; // sfix28_E55
  wire signed [27:0] section_out12; // sfix28_E55
  wire signed [27:0] sub_cast_2; // sfix28_E55
  wire signed [27:0] sub_cast_3; // sfix28_E55
  wire signed [28:0] sub_temp_1; // sfix29_E55
  reg  signed [27:0] cic_pipeline12; // sfix28_E55
  //   -- Section 13 Signals 
  wire signed [27:0] section_in13; // sfix28_E55
  wire signed [26:0] section_cast13; // sfix27_E56
  reg  signed [26:0] diff3; // sfix27_E56
  wire signed [26:0] section_out13; // sfix27_E56
  wire signed [26:0] sub_cast_4; // sfix27_E56
  wire signed [26:0] sub_cast_5; // sfix27_E56
  wire signed [27:0] sub_temp_2; // sfix28_E56
  reg  signed [26:0] cic_pipeline13; // sfix27_E56
  //   -- Section 14 Signals 
  wire signed [26:0] section_in14; // sfix27_E56
  reg  signed [26:0] diff4; // sfix27_E56
  wire signed [26:0] section_out14; // sfix27_E56
  wire signed [26:0] sub_cast_6; // sfix27_E56
  wire signed [26:0] sub_cast_7; // sfix27_E56
  wire signed [27:0] sub_temp_3; // sfix28_E56
  reg  signed [26:0] cic_pipeline14; // sfix27_E56
  //   -- Section 15 Signals 
  wire signed [26:0] section_in15; // sfix27_E56
  wire signed [25:0] section_cast15; // sfix26_E57
  reg  signed [25:0] diff5; // sfix26_E57
  wire signed [25:0] section_out15; // sfix26_E57
  wire signed [25:0] sub_cast_8; // sfix26_E57
  wire signed [25:0] sub_cast_9; // sfix26_E57
  wire signed [26:0] sub_temp_4; // sfix27_E57
  reg  signed [25:0] cic_pipeline15; // sfix26_E57
  //   -- Section 16 Signals 
  wire signed [25:0] section_in16; // sfix26_E57
  wire signed [24:0] section_cast16; // sfix25_E58
  reg  signed [24:0] diff6; // sfix25_E58
  wire signed [24:0] section_out16; // sfix25_E58
  wire signed [24:0] sub_cast_10; // sfix25_E58
  wire signed [24:0] sub_cast_11; // sfix25_E58
  wire signed [25:0] sub_temp_5; // sfix26_E58
  reg  signed [24:0] cic_pipeline16; // sfix25_E58
  //   -- Section 17 Signals 
  wire signed [24:0] section_in17; // sfix25_E58
  wire signed [23:0] section_cast17; // sfix24_E59
  reg  signed [23:0] diff7; // sfix24_E59
  wire signed [23:0] section_out17; // sfix24_E59
  wire signed [23:0] sub_cast_12; // sfix24_E59
  wire signed [23:0] sub_cast_13; // sfix24_E59
  wire signed [24:0] sub_temp_6; // sfix25_E59
  reg  signed [23:0] cic_pipeline17; // sfix24_E59
  //   -- Section 18 Signals 
  wire signed [23:0] section_in18; // sfix24_E59
  wire signed [22:0] section_cast18; // sfix23_E60
  reg  signed [22:0] diff8; // sfix23_E60
  wire signed [22:0] section_out18; // sfix23_E60
  wire signed [22:0] sub_cast_14; // sfix23_E60
  wire signed [22:0] sub_cast_15; // sfix23_E60
  wire signed [23:0] sub_temp_7; // sfix24_E60
  reg  signed [22:0] cic_pipeline18; // sfix23_E60
  //   -- Section 19 Signals 
  wire signed [22:0] section_in19; // sfix23_E60
  wire signed [21:0] section_cast19; // sfix22_E61
  reg  signed [21:0] diff9; // sfix22_E61
  wire signed [21:0] section_out19; // sfix22_E61
  wire signed [21:0] sub_cast_16; // sfix22_E61
  wire signed [21:0] sub_cast_17; // sfix22_E61
  wire signed [22:0] sub_temp_8; // sfix23_E61
  reg  signed [21:0] cic_pipeline19; // sfix22_E61
  //   -- Section 20 Signals 
  wire signed [21:0] section_in20; // sfix22_E61
  wire signed [20:0] section_cast20; // sfix21_E62
  reg  signed [20:0] diff10; // sfix21_E62
  wire signed [20:0] section_out20; // sfix21_E62
  wire signed [20:0] sub_cast_18; // sfix21_E62
  wire signed [20:0] sub_cast_19; // sfix21_E62
  wire signed [21:0] sub_temp_9; // sfix22_E62
  wire signed [17:0] output_typeconvert; // sfix18_E65
  //   
  reg  signed [17:0] output_register; // sfix18_E65

  // Block Statements
  //   ------------------ CE Output Generation ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 7'b0000000;
      end
      else begin
        if (clk_enable == 1'b1) begin
          if (cur_count == 7'b1100011) begin
            cur_count <= 7'b0000000;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  assign  phase_1 = (cur_count == 7'b0000001 && clk_enable == 1'b1)? 1 : 0;

  always @( posedge clk or posedge reset)
    begin: ce_delay
      if (reset == 1'b1) begin
        int_delay_pipe[0] <= 1'b0;
        int_delay_pipe[1] <= 1'b0;
        int_delay_pipe[2] <= 1'b0;
        int_delay_pipe[3] <= 1'b0;
        int_delay_pipe[4] <= 1'b0;
        int_delay_pipe[5] <= 1'b0;
        int_delay_pipe[6] <= 1'b0;
        int_delay_pipe[7] <= 1'b0;
        int_delay_pipe[8] <= 1'b0;
      end
      else begin
        if (phase_1 == 1'b1) begin
        int_delay_pipe[0] <= clk_enable;
        int_delay_pipe[1] <= int_delay_pipe[0];
        int_delay_pipe[2] <= int_delay_pipe[1];
        int_delay_pipe[3] <= int_delay_pipe[2];
        int_delay_pipe[4] <= int_delay_pipe[3];
        int_delay_pipe[5] <= int_delay_pipe[4];
        int_delay_pipe[6] <= int_delay_pipe[5];
        int_delay_pipe[7] <= int_delay_pipe[6];
        int_delay_pipe[8] <= int_delay_pipe[7];
        end
      end
    end // ce_delay

    assign ce_delayline = int_delay_pipe[8];
  assign ce_gated =  ce_delayline & phase_1;

  //   ------------------ CE Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output_register
      if (reset == 1'b1) begin
        ce_out_reg <= 1'b0;
      end
      else begin
          ce_out_reg <= ce_gated;
      end
    end // ce_output_register

  //   ------------------ Input Register ------------------

  always @ (posedge clk or posedge reset)
    begin: input_reg_process
      if (reset == 1'b1) begin
        input_register <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          input_register <= filter_in;
        end
      end
    end // input_reg_process

  //   ------------------ Section # 1 : Integrator ------------------

  assign section_in1 = input_register;

  assign section_cast1 = $signed({64{section_in1[15]}});

  assign add_cast = section_cast1;
  assign add_cast_1 = section_out1;
  assign add_temp = add_cast + add_cast_1;
  assign sum1 = add_temp[63:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section1
      if (reset == 1'b1) begin
        section_out1 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out1 <= sum1;
        end
      end
    end // integrator_delay_section1

  //   ------------------ Section # 2 : Integrator ------------------

  assign section_in2 = section_out1;

  assign add_cast_2 = section_in2;
  assign add_cast_3 = section_out2;
  assign add_temp_1 = add_cast_2 + add_cast_3;
  assign sum2 = add_temp_1[63:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section2
      if (reset == 1'b1) begin
        section_out2 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out2 <= sum2;
        end
      end
    end // integrator_delay_section2

  //   ------------------ Section # 3 : Integrator ------------------

  assign section_in3 = section_out2;

  assign add_cast_4 = section_in3;
  assign add_cast_5 = section_out3;
  assign add_temp_2 = add_cast_4 + add_cast_5;
  assign sum3 = add_temp_2[63:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section3
      if (reset == 1'b1) begin
        section_out3 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out3 <= sum3;
        end
      end
    end // integrator_delay_section3

  //   ------------------ Section # 4 : Integrator ------------------

  assign section_in4 = section_out3;

  assign add_cast_6 = section_in4;
  assign add_cast_7 = section_out4;
  assign add_temp_3 = add_cast_6 + add_cast_7;
  assign sum4 = add_temp_3[63:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section4
      if (reset == 1'b1) begin
        section_out4 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out4 <= sum4;
        end
      end
    end // integrator_delay_section4

  //   ------------------ Section # 5 : Integrator ------------------

  assign section_in5 = section_out4;

  assign add_cast_8 = section_in5;
  assign add_cast_9 = section_out5;
  assign add_temp_4 = add_cast_8 + add_cast_9;
  assign sum5 = add_temp_4[63:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section5
      if (reset == 1'b1) begin
        section_out5 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out5 <= sum5;
        end
      end
    end // integrator_delay_section5

  //   ------------------ Section # 6 : Integrator ------------------

  assign section_in6 = section_out5;

  assign section_cast6 = section_in6[63:1];

  assign add_cast_10 = section_cast6;
  assign add_cast_11 = section_out6;
  assign add_temp_5 = add_cast_10 + add_cast_11;
  assign sum6 = add_temp_5[62:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section6
      if (reset == 1'b1) begin
        section_out6 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out6 <= sum6;
        end
      end
    end // integrator_delay_section6

  //   ------------------ Section # 7 : Integrator ------------------

  assign section_in7 = section_out6;

  assign section_cast7 = section_in7[62:16];

  assign add_cast_12 = section_cast7;
  assign add_cast_13 = section_out7;
  assign add_temp_6 = add_cast_12 + add_cast_13;
  assign sum7 = add_temp_6[46:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section7
      if (reset == 1'b1) begin
        section_out7 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out7 <= sum7;
        end
      end
    end // integrator_delay_section7

  //   ------------------ Section # 8 : Integrator ------------------

  assign section_in8 = section_out7;

  assign section_cast8 = section_in8[46:5];

  assign add_cast_14 = section_cast8;
  assign add_cast_15 = section_out8;
  assign add_temp_7 = add_cast_14 + add_cast_15;
  assign sum8 = add_temp_7[41:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section8
      if (reset == 1'b1) begin
        section_out8 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out8 <= sum8;
        end
      end
    end // integrator_delay_section8

  //   ------------------ Section # 9 : Integrator ------------------

  assign section_in9 = section_out8;

  assign section_cast9 = section_in9[41:5];

  assign add_cast_16 = section_cast9;
  assign add_cast_17 = section_out9;
  assign add_temp_8 = add_cast_16 + add_cast_17;
  assign sum9 = add_temp_8[36:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section9
      if (reset == 1'b1) begin
        section_out9 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out9 <= sum9;
        end
      end
    end // integrator_delay_section9

  //   ------------------ Section # 10 : Integrator ------------------

  assign section_in10 = section_out9;

  assign section_cast10 = section_in10[36:5];

  assign add_cast_18 = section_cast10;
  assign add_cast_19 = section_out10;
  assign add_temp_9 = add_cast_18 + add_cast_19;
  assign sum10 = add_temp_9[31:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section10
      if (reset == 1'b1) begin
        section_out10 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out10 <= sum10;
        end
      end
    end // integrator_delay_section10

  //   ------------------ Section # 11 : Comb ------------------

  assign section_in11 = section_out10;

  assign section_cast11 = section_in11[31:3];

  assign sub_cast = section_cast11;
  assign sub_cast_1 = diff1;
  assign sub_temp = sub_cast - sub_cast_1;
  assign section_out11 = sub_temp[28:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section11
      if (reset == 1'b1) begin
        diff1 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff1 <= section_cast11;
        end
      end
    end // comb_delay_section11

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section11
      if (reset == 1'b1) begin
        cic_pipeline11 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline11 <= section_out11;
        end
      end
    end // cic_pipeline_process_section11

  //   ------------------ Section # 12 : Comb ------------------

  assign section_in12 = cic_pipeline11;

  assign section_cast12 = section_in12[28:1];

  assign sub_cast_2 = section_cast12;
  assign sub_cast_3 = diff2;
  assign sub_temp_1 = sub_cast_2 - sub_cast_3;
  assign section_out12 = sub_temp_1[27:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section12
      if (reset == 1'b1) begin
        diff2 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff2 <= section_cast12;
        end
      end
    end // comb_delay_section12

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section12
      if (reset == 1'b1) begin
        cic_pipeline12 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline12 <= section_out12;
        end
      end
    end // cic_pipeline_process_section12

  //   ------------------ Section # 13 : Comb ------------------

  assign section_in13 = cic_pipeline12;

  assign section_cast13 = section_in13[27:1];

  assign sub_cast_4 = section_cast13;
  assign sub_cast_5 = diff3;
  assign sub_temp_2 = sub_cast_4 - sub_cast_5;
  assign section_out13 = sub_temp_2[26:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section13
      if (reset == 1'b1) begin
        diff3 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff3 <= section_cast13;
        end
      end
    end // comb_delay_section13

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section13
      if (reset == 1'b1) begin
        cic_pipeline13 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline13 <= section_out13;
        end
      end
    end // cic_pipeline_process_section13

  //   ------------------ Section # 14 : Comb ------------------

  assign section_in14 = cic_pipeline13;

  assign sub_cast_6 = section_in14;
  assign sub_cast_7 = diff4;
  assign sub_temp_3 = sub_cast_6 - sub_cast_7;
  assign section_out14 = sub_temp_3[26:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section14
      if (reset == 1'b1) begin
        diff4 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff4 <= section_in14;
        end
      end
    end // comb_delay_section14

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section14
      if (reset == 1'b1) begin
        cic_pipeline14 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline14 <= section_out14;
        end
      end
    end // cic_pipeline_process_section14

  //   ------------------ Section # 15 : Comb ------------------

  assign section_in15 = cic_pipeline14;

  assign section_cast15 = section_in15[26:1];

  assign sub_cast_8 = section_cast15;
  assign sub_cast_9 = diff5;
  assign sub_temp_4 = sub_cast_8 - sub_cast_9;
  assign section_out15 = sub_temp_4[25:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section15
      if (reset == 1'b1) begin
        diff5 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff5 <= section_cast15;
        end
      end
    end // comb_delay_section15

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section15
      if (reset == 1'b1) begin
        cic_pipeline15 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline15 <= section_out15;
        end
      end
    end // cic_pipeline_process_section15

  //   ------------------ Section # 16 : Comb ------------------

  assign section_in16 = cic_pipeline15;

  assign section_cast16 = section_in16[25:1];

  assign sub_cast_10 = section_cast16;
  assign sub_cast_11 = diff6;
  assign sub_temp_5 = sub_cast_10 - sub_cast_11;
  assign section_out16 = sub_temp_5[24:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section16
      if (reset == 1'b1) begin
        diff6 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff6 <= section_cast16;
        end
      end
    end // comb_delay_section16

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section16
      if (reset == 1'b1) begin
        cic_pipeline16 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline16 <= section_out16;
        end
      end
    end // cic_pipeline_process_section16

  //   ------------------ Section # 17 : Comb ------------------

  assign section_in17 = cic_pipeline16;

  assign section_cast17 = section_in17[24:1];

  assign sub_cast_12 = section_cast17;
  assign sub_cast_13 = diff7;
  assign sub_temp_6 = sub_cast_12 - sub_cast_13;
  assign section_out17 = sub_temp_6[23:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section17
      if (reset == 1'b1) begin
        diff7 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff7 <= section_cast17;
        end
      end
    end // comb_delay_section17

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section17
      if (reset == 1'b1) begin
        cic_pipeline17 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline17 <= section_out17;
        end
      end
    end // cic_pipeline_process_section17

  //   ------------------ Section # 18 : Comb ------------------

  assign section_in18 = cic_pipeline17;

  assign section_cast18 = section_in18[23:1];

  assign sub_cast_14 = section_cast18;
  assign sub_cast_15 = diff8;
  assign sub_temp_7 = sub_cast_14 - sub_cast_15;
  assign section_out18 = sub_temp_7[22:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section18
      if (reset == 1'b1) begin
        diff8 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff8 <= section_cast18;
        end
      end
    end // comb_delay_section18

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section18
      if (reset == 1'b1) begin
        cic_pipeline18 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline18 <= section_out18;
        end
      end
    end // cic_pipeline_process_section18

  //   ------------------ Section # 19 : Comb ------------------

  assign section_in19 = cic_pipeline18;

  assign section_cast19 = section_in19[22:1];

  assign sub_cast_16 = section_cast19;
  assign sub_cast_17 = diff9;
  assign sub_temp_8 = sub_cast_16 - sub_cast_17;
  assign section_out19 = sub_temp_8[21:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section19
      if (reset == 1'b1) begin
        diff9 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff9 <= section_cast19;
        end
      end
    end // comb_delay_section19

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section19
      if (reset == 1'b1) begin
        cic_pipeline19 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline19 <= section_out19;
        end
      end
    end // cic_pipeline_process_section19

  //   ------------------ Section # 20 : Comb ------------------

  assign section_in20 = cic_pipeline19;

  assign section_cast20 = section_in20[21:1];

  assign sub_cast_18 = section_cast20;
  assign sub_cast_19 = diff10;
  assign sub_temp_9 = sub_cast_18 - sub_cast_19;
  assign section_out20 = sub_temp_9[20:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section20
      if (reset == 1'b1) begin
        diff10 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff10 <= section_cast20;
        end
      end
    end // comb_delay_section20

  assign output_typeconvert = section_out20[20:3];

  //   ------------------ Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: output_reg_process
      if (reset == 1'b1) begin
        output_register <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          output_register <= output_typeconvert;
        end
      end
    end // output_reg_process

  // Assignment Statements
  assign ce_out = ce_out_reg;
  assign filter_out = output_register;
endmodule  // CIC_R100_M1_N10
