// -------------------------------------------------------------
//
// Module: CIC_R256_M1_N6
//
// Generated by MATLAB(R) 7.2 and the Filter Design HDL Coder 1.4.
//
// Generated on: 2006-09-15 18:26:49
//
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// TargetLanguage: Verilog
// Name: CIC_R256_M1_N6
// TargetDirectory: c:\data
// FIRAdderStyle: tree
// CoeffMultipliers: csd
// SerialPartition: -1
// AddPipelineRegisters: On
// CastBeforeSum: On
//
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure        : Cascaded Integrator-Comb Decimator
// Decimation Factor       : 256
// Differential Delay      : 1
// Number of Sections      : 6
// Stable                  : Yes
// Linear Phase            : Yes (Type 1)
//
// Input                   : s16,0
// Output                  : s16,-48
// Filter Internals        : Minimum Word Lengths
//   Integrator Section 1  : s58,-6
//   Integrator Section 2  : s58,-6
//   Integrator Section 3  : s46,-18
//   Integrator Section 4  : s39,-25
//   Integrator Section 5  : s33,-31
//   Integrator Section 6  : s26,-38
//   Comb Section 1        : s23,-41
//   Comb Section 2        : s22,-42
//   Comb Section 3        : s21,-43
//   Comb Section 4        : s20,-44
//   Comb Section 5        : s20,-44
//   Comb Section 6        : s19,-45
//
// Implementation Cost
// Number of Multipliers : 0
// Number of Adders      : 12
// Number of States      : 12
// MultPerInputSample    : 0
// AddPerInputSample     : 6.0234
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module CIC_R256_M1_N6 
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [15:0] filter_in; //sfix16
  output  signed [15:0] filter_out; //sfix16_E48
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: CIC_R256_M1_N6
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  // Signals
  reg  [7:0] cur_count; // ufix8
  wire phase_1; // boolean
  wire ce_delayline; // boolean
  reg  int_delay_pipe [0:4] ; // boolean
  wire ce_gated; // boolean
  reg  ce_out_reg; // boolean
  //   
  reg  signed [15:0] input_register; // sfix16
  //   -- Section 1 Signals 
  wire signed [15:0] section_in1; // sfix16
  wire signed [57:0] section_cast1; // sfix58_E6
  wire signed [57:0] sum1; // sfix58_E6
  reg  signed [57:0] section_out1; // sfix58_E6
  wire signed [57:0] add_cast; // sfix58_E6
  wire signed [57:0] add_cast_1; // sfix58_E6
  wire signed [58:0] add_temp; // sfix59_E6
  //   -- Section 2 Signals 
  wire signed [57:0] section_in2; // sfix58_E6
  wire signed [57:0] sum2; // sfix58_E6
  reg  signed [57:0] section_out2; // sfix58_E6
  wire signed [57:0] add_cast_2; // sfix58_E6
  wire signed [57:0] add_cast_3; // sfix58_E6
  wire signed [58:0] add_temp_1; // sfix59_E6
  //   -- Section 3 Signals 
  wire signed [57:0] section_in3; // sfix58_E6
  wire signed [45:0] section_cast3; // sfix46_E18
  wire signed [45:0] sum3; // sfix46_E18
  reg  signed [45:0] section_out3; // sfix46_E18
  wire signed [45:0] add_cast_4; // sfix46_E18
  wire signed [45:0] add_cast_5; // sfix46_E18
  wire signed [46:0] add_temp_2; // sfix47_E18
  //   -- Section 4 Signals 
  wire signed [45:0] section_in4; // sfix46_E18
  wire signed [38:0] section_cast4; // sfix39_E25
  wire signed [38:0] sum4; // sfix39_E25
  reg  signed [38:0] section_out4; // sfix39_E25
  wire signed [38:0] add_cast_6; // sfix39_E25
  wire signed [38:0] add_cast_7; // sfix39_E25
  wire signed [39:0] add_temp_3; // sfix40_E25
  //   -- Section 5 Signals 
  wire signed [38:0] section_in5; // sfix39_E25
  wire signed [32:0] section_cast5; // sfix33_E31
  wire signed [32:0] sum5; // sfix33_E31
  reg  signed [32:0] section_out5; // sfix33_E31
  wire signed [32:0] add_cast_8; // sfix33_E31
  wire signed [32:0] add_cast_9; // sfix33_E31
  wire signed [33:0] add_temp_4; // sfix34_E31
  //   -- Section 6 Signals 
  wire signed [32:0] section_in6; // sfix33_E31
  wire signed [25:0] section_cast6; // sfix26_E38
  wire signed [25:0] sum6; // sfix26_E38
  reg  signed [25:0] section_out6; // sfix26_E38
  wire signed [25:0] add_cast_10; // sfix26_E38
  wire signed [25:0] add_cast_11; // sfix26_E38
  wire signed [26:0] add_temp_5; // sfix27_E38
  //   -- Section 7 Signals 
  wire signed [25:0] section_in7; // sfix26_E38
  wire signed [22:0] section_cast7; // sfix23_E41
  reg  signed [22:0] diff1; // sfix23_E41
  wire signed [22:0] section_out7; // sfix23_E41
  wire signed [22:0] sub_cast; // sfix23_E41
  wire signed [22:0] sub_cast_1; // sfix23_E41
  wire signed [23:0] sub_temp; // sfix24_E41
  reg  signed [22:0] cic_pipeline7; // sfix23_E41
  //   -- Section 8 Signals 
  wire signed [22:0] section_in8; // sfix23_E41
  wire signed [21:0] section_cast8; // sfix22_E42
  reg  signed [21:0] diff2; // sfix22_E42
  wire signed [21:0] section_out8; // sfix22_E42
  wire signed [21:0] sub_cast_2; // sfix22_E42
  wire signed [21:0] sub_cast_3; // sfix22_E42
  wire signed [22:0] sub_temp_1; // sfix23_E42
  reg  signed [21:0] cic_pipeline8; // sfix22_E42
  //   -- Section 9 Signals 
  wire signed [21:0] section_in9; // sfix22_E42
  wire signed [20:0] section_cast9; // sfix21_E43
  reg  signed [20:0] diff3; // sfix21_E43
  wire signed [20:0] section_out9; // sfix21_E43
  wire signed [20:0] sub_cast_4; // sfix21_E43
  wire signed [20:0] sub_cast_5; // sfix21_E43
  wire signed [21:0] sub_temp_2; // sfix22_E43
  reg  signed [20:0] cic_pipeline9; // sfix21_E43
  //   -- Section 10 Signals 
  wire signed [20:0] section_in10; // sfix21_E43
  wire signed [19:0] section_cast10; // sfix20_E44
  reg  signed [19:0] diff4; // sfix20_E44
  wire signed [19:0] section_out10; // sfix20_E44
  wire signed [19:0] sub_cast_6; // sfix20_E44
  wire signed [19:0] sub_cast_7; // sfix20_E44
  wire signed [20:0] sub_temp_3; // sfix21_E44
  reg  signed [19:0] cic_pipeline10; // sfix20_E44
  //   -- Section 11 Signals 
  wire signed [19:0] section_in11; // sfix20_E44
  reg  signed [19:0] diff5; // sfix20_E44
  wire signed [19:0] section_out11; // sfix20_E44
  wire signed [19:0] sub_cast_8; // sfix20_E44
  wire signed [19:0] sub_cast_9; // sfix20_E44
  wire signed [20:0] sub_temp_4; // sfix21_E44
  reg  signed [19:0] cic_pipeline11; // sfix20_E44
  //   -- Section 12 Signals 
  wire signed [19:0] section_in12; // sfix20_E44
  wire signed [18:0] section_cast12; // sfix19_E45
  reg  signed [18:0] diff6; // sfix19_E45
  wire signed [18:0] section_out12; // sfix19_E45
  wire signed [18:0] sub_cast_10; // sfix19_E45
  wire signed [18:0] sub_cast_11; // sfix19_E45
  wire signed [19:0] sub_temp_5; // sfix20_E45
  wire signed [15:0] output_typeconvert; // sfix16_E48
  //   
  reg  signed [15:0] output_register; // sfix16_E48

  // Block Statements
  //   ------------------ CE Output Generation ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 8'b00000000;
      end
      else begin
        if (clk_enable == 1'b1) begin
          if (cur_count == 8'b11111111) begin
            cur_count <= 8'b00000000;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  assign  phase_1 = (cur_count == 8'b00000001 && clk_enable == 1'b1)? 1 : 0;

  always @( posedge clk or posedge reset)
    begin: ce_delay
      if (reset == 1'b1) begin
        int_delay_pipe[0] <= 1'b0;
        int_delay_pipe[1] <= 1'b0;
        int_delay_pipe[2] <= 1'b0;
        int_delay_pipe[3] <= 1'b0;
        int_delay_pipe[4] <= 1'b0;
      end
      else begin
        if (phase_1 == 1'b1) begin
        int_delay_pipe[0] <= clk_enable;
        int_delay_pipe[1] <= int_delay_pipe[0];
        int_delay_pipe[2] <= int_delay_pipe[1];
        int_delay_pipe[3] <= int_delay_pipe[2];
        int_delay_pipe[4] <= int_delay_pipe[3];
        end
      end
    end // ce_delay

    assign ce_delayline = int_delay_pipe[4];
  assign ce_gated =  ce_delayline & phase_1;

  //   ------------------ CE Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output_register
      if (reset == 1'b1) begin
        ce_out_reg <= 1'b0;
      end
      else begin
          ce_out_reg <= ce_gated;
      end
    end // ce_output_register

  //   ------------------ Input Register ------------------

  always @ (posedge clk or posedge reset)
    begin: input_reg_process
      if (reset == 1'b1) begin
        input_register <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          input_register <= filter_in;
        end
      end
    end // input_reg_process

  //   ------------------ Section # 1 : Integrator ------------------

  assign section_in1 = input_register;

  assign section_cast1 = $signed({{48{section_in1[15]}}, section_in1[15:6]});

  assign add_cast = section_cast1;
  assign add_cast_1 = section_out1;
  assign add_temp = add_cast + add_cast_1;
  assign sum1 = add_temp[57:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section1
      if (reset == 1'b1) begin
        section_out1 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out1 <= sum1;
        end
      end
    end // integrator_delay_section1

  //   ------------------ Section # 2 : Integrator ------------------

  assign section_in2 = section_out1;

  assign add_cast_2 = section_in2;
  assign add_cast_3 = section_out2;
  assign add_temp_1 = add_cast_2 + add_cast_3;
  assign sum2 = add_temp_1[57:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section2
      if (reset == 1'b1) begin
        section_out2 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out2 <= sum2;
        end
      end
    end // integrator_delay_section2

  //   ------------------ Section # 3 : Integrator ------------------

  assign section_in3 = section_out2;

  assign section_cast3 = section_in3[57:12];

  assign add_cast_4 = section_cast3;
  assign add_cast_5 = section_out3;
  assign add_temp_2 = add_cast_4 + add_cast_5;
  assign sum3 = add_temp_2[45:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section3
      if (reset == 1'b1) begin
        section_out3 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out3 <= sum3;
        end
      end
    end // integrator_delay_section3

  //   ------------------ Section # 4 : Integrator ------------------

  assign section_in4 = section_out3;

  assign section_cast4 = section_in4[45:7];

  assign add_cast_6 = section_cast4;
  assign add_cast_7 = section_out4;
  assign add_temp_3 = add_cast_6 + add_cast_7;
  assign sum4 = add_temp_3[38:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section4
      if (reset == 1'b1) begin
        section_out4 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out4 <= sum4;
        end
      end
    end // integrator_delay_section4

  //   ------------------ Section # 5 : Integrator ------------------

  assign section_in5 = section_out4;

  assign section_cast5 = section_in5[38:6];

  assign add_cast_8 = section_cast5;
  assign add_cast_9 = section_out5;
  assign add_temp_4 = add_cast_8 + add_cast_9;
  assign sum5 = add_temp_4[32:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section5
      if (reset == 1'b1) begin
        section_out5 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out5 <= sum5;
        end
      end
    end // integrator_delay_section5

  //   ------------------ Section # 6 : Integrator ------------------

  assign section_in6 = section_out5;

  assign section_cast6 = section_in6[32:7];

  assign add_cast_10 = section_cast6;
  assign add_cast_11 = section_out6;
  assign add_temp_5 = add_cast_10 + add_cast_11;
  assign sum6 = add_temp_5[25:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section6
      if (reset == 1'b1) begin
        section_out6 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out6 <= sum6;
        end
      end
    end // integrator_delay_section6

  //   ------------------ Section # 7 : Comb ------------------

  assign section_in7 = section_out6;

  assign section_cast7 = section_in7[25:3];

  assign sub_cast = section_cast7;
  assign sub_cast_1 = diff1;
  assign sub_temp = sub_cast - sub_cast_1;
  assign section_out7 = sub_temp[22:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section7
      if (reset == 1'b1) begin
        diff1 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff1 <= section_cast7;
        end
      end
    end // comb_delay_section7

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section7
      if (reset == 1'b1) begin
        cic_pipeline7 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline7 <= section_out7;
        end
      end
    end // cic_pipeline_process_section7

  //   ------------------ Section # 8 : Comb ------------------

  assign section_in8 = cic_pipeline7;

  assign section_cast8 = section_in8[22:1];

  assign sub_cast_2 = section_cast8;
  assign sub_cast_3 = diff2;
  assign sub_temp_1 = sub_cast_2 - sub_cast_3;
  assign section_out8 = sub_temp_1[21:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section8
      if (reset == 1'b1) begin
        diff2 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff2 <= section_cast8;
        end
      end
    end // comb_delay_section8

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section8
      if (reset == 1'b1) begin
        cic_pipeline8 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline8 <= section_out8;
        end
      end
    end // cic_pipeline_process_section8

  //   ------------------ Section # 9 : Comb ------------------

  assign section_in9 = cic_pipeline8;

  assign section_cast9 = section_in9[21:1];

  assign sub_cast_4 = section_cast9;
  assign sub_cast_5 = diff3;
  assign sub_temp_2 = sub_cast_4 - sub_cast_5;
  assign section_out9 = sub_temp_2[20:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section9
      if (reset == 1'b1) begin
        diff3 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff3 <= section_cast9;
        end
      end
    end // comb_delay_section9

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section9
      if (reset == 1'b1) begin
        cic_pipeline9 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline9 <= section_out9;
        end
      end
    end // cic_pipeline_process_section9

  //   ------------------ Section # 10 : Comb ------------------

  assign section_in10 = cic_pipeline9;

  assign section_cast10 = section_in10[20:1];

  assign sub_cast_6 = section_cast10;
  assign sub_cast_7 = diff4;
  assign sub_temp_3 = sub_cast_6 - sub_cast_7;
  assign section_out10 = sub_temp_3[19:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section10
      if (reset == 1'b1) begin
        diff4 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff4 <= section_cast10;
        end
      end
    end // comb_delay_section10

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section10
      if (reset == 1'b1) begin
        cic_pipeline10 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline10 <= section_out10;
        end
      end
    end // cic_pipeline_process_section10

  //   ------------------ Section # 11 : Comb ------------------

  assign section_in11 = cic_pipeline10;

  assign sub_cast_8 = section_in11;
  assign sub_cast_9 = diff5;
  assign sub_temp_4 = sub_cast_8 - sub_cast_9;
  assign section_out11 = sub_temp_4[19:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section11
      if (reset == 1'b1) begin
        diff5 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff5 <= section_in11;
        end
      end
    end // comb_delay_section11

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section11
      if (reset == 1'b1) begin
        cic_pipeline11 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline11 <= section_out11;
        end
      end
    end // cic_pipeline_process_section11

  //   ------------------ Section # 12 : Comb ------------------

  assign section_in12 = cic_pipeline11;

  assign section_cast12 = section_in12[19:1];

  assign sub_cast_10 = section_cast12;
  assign sub_cast_11 = diff6;
  assign sub_temp_5 = sub_cast_10 - sub_cast_11;
  assign section_out12 = sub_temp_5[18:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section12
      if (reset == 1'b1) begin
        diff6 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff6 <= section_cast12;
        end
      end
    end // comb_delay_section12

  assign output_typeconvert = section_out12[18:3];

  //   ------------------ Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: output_reg_process
      if (reset == 1'b1) begin
        output_register <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          output_register <= output_typeconvert;
        end
      end
    end // output_reg_process

  // Assignment Statements
  assign ce_out = ce_out_reg;
  assign filter_out = output_register;
endmodule  // CIC_R256_M1_N6
