// -------------------------------------------------------------
//
// Module: CIC_R64_M1_N4
//
// Generated by MATLAB(R) 7.2 and the Filter Design HDL Coder 1.4.
//
// Generated on: 2006-09-07 17:35:04
//
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// TargetLanguage: Verilog
// Name: CIC_R64_M1_N4
// TargetDirectory: c:\data
// FIRAdderStyle: tree
// CoeffMultipliers: csd
// SerialPartition: -1
// AddPipelineRegisters: On
// CastBeforeSum: On
//
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure        : Cascaded Integrator-Comb Decimator
// Decimation Factor       : 64
// Differential Delay      : 1
// Number of Sections      : 4
// Stable                  : Yes
// Linear Phase            : Yes (Type 1)
//
// Input                   : s16,0
// Output                  : s18,-22
// Filter Internals        : Minimum Word Lengths
//   Integrator Section 1  : s40,0
//   Integrator Section 2  : s35,-5
//   Integrator Section 3  : s30,-10
//   Integrator Section 4  : s25,-15
//   Comb Section 1        : s23,-17
//   Comb Section 2        : s22,-18
//   Comb Section 3        : s21,-19
//   Comb Section 4        : s20,-20
//
// Implementation Cost
// Number of Multipliers : 0
// Number of Adders      : 8
// Number of States      : 8
// MultPerInputSample    : 0
// AddPerInputSample     : 4.0625
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module CIC_R64_M1_N4 
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [15:0] filter_in; //sfix16
  output  signed [17:0] filter_out; //sfix18_E22
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: CIC_R64_M1_N4
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  // Signals
  reg  [5:0] cur_count; // ufix6
  wire phase_1; // boolean
  wire ce_delayline; // boolean
  reg  int_delay_pipe [0:2] ; // boolean
  wire ce_gated; // boolean
  reg  ce_out_reg; // boolean
  //   
  reg  signed [15:0] input_register; // sfix16
  //   -- Section 1 Signals 
  wire signed [15:0] section_in1; // sfix16
  wire signed [39:0] section_cast1; // sfix40
  wire signed [39:0] sum1; // sfix40
  reg  signed [39:0] section_out1; // sfix40
  wire signed [39:0] add_cast; // sfix40
  wire signed [39:0] add_cast_1; // sfix40
  wire signed [40:0] add_temp; // sfix41
  //   -- Section 2 Signals 
  wire signed [39:0] section_in2; // sfix40
  wire signed [34:0] section_cast2; // sfix35_E5
  wire signed [34:0] sum2; // sfix35_E5
  reg  signed [34:0] section_out2; // sfix35_E5
  wire signed [34:0] add_cast_2; // sfix35_E5
  wire signed [34:0] add_cast_3; // sfix35_E5
  wire signed [35:0] add_temp_1; // sfix36_E5
  //   -- Section 3 Signals 
  wire signed [34:0] section_in3; // sfix35_E5
  wire signed [29:0] section_cast3; // sfix30_E10
  wire signed [29:0] sum3; // sfix30_E10
  reg  signed [29:0] section_out3; // sfix30_E10
  wire signed [29:0] add_cast_4; // sfix30_E10
  wire signed [29:0] add_cast_5; // sfix30_E10
  wire signed [30:0] add_temp_2; // sfix31_E10
  //   -- Section 4 Signals 
  wire signed [29:0] section_in4; // sfix30_E10
  wire signed [24:0] section_cast4; // sfix25_E15
  wire signed [24:0] sum4; // sfix25_E15
  reg  signed [24:0] section_out4; // sfix25_E15
  wire signed [24:0] add_cast_6; // sfix25_E15
  wire signed [24:0] add_cast_7; // sfix25_E15
  wire signed [25:0] add_temp_3; // sfix26_E15
  //   -- Section 5 Signals 
  wire signed [24:0] section_in5; // sfix25_E15
  wire signed [22:0] section_cast5; // sfix23_E17
  reg  signed [22:0] diff1; // sfix23_E17
  wire signed [22:0] section_out5; // sfix23_E17
  wire signed [22:0] sub_cast; // sfix23_E17
  wire signed [22:0] sub_cast_1; // sfix23_E17
  wire signed [23:0] sub_temp; // sfix24_E17
  reg  signed [22:0] cic_pipeline5; // sfix23_E17
  //   -- Section 6 Signals 
  wire signed [22:0] section_in6; // sfix23_E17
  wire signed [21:0] section_cast6; // sfix22_E18
  reg  signed [21:0] diff2; // sfix22_E18
  wire signed [21:0] section_out6; // sfix22_E18
  wire signed [21:0] sub_cast_2; // sfix22_E18
  wire signed [21:0] sub_cast_3; // sfix22_E18
  wire signed [22:0] sub_temp_1; // sfix23_E18
  reg  signed [21:0] cic_pipeline6; // sfix22_E18
  //   -- Section 7 Signals 
  wire signed [21:0] section_in7; // sfix22_E18
  wire signed [20:0] section_cast7; // sfix21_E19
  reg  signed [20:0] diff3; // sfix21_E19
  wire signed [20:0] section_out7; // sfix21_E19
  wire signed [20:0] sub_cast_4; // sfix21_E19
  wire signed [20:0] sub_cast_5; // sfix21_E19
  wire signed [21:0] sub_temp_2; // sfix22_E19
  reg  signed [20:0] cic_pipeline7; // sfix21_E19
  //   -- Section 8 Signals 
  wire signed [20:0] section_in8; // sfix21_E19
  wire signed [19:0] section_cast8; // sfix20_E20
  reg  signed [19:0] diff4; // sfix20_E20
  wire signed [19:0] section_out8; // sfix20_E20
  wire signed [19:0] sub_cast_6; // sfix20_E20
  wire signed [19:0] sub_cast_7; // sfix20_E20
  wire signed [20:0] sub_temp_3; // sfix21_E20
  wire signed [17:0] output_typeconvert; // sfix18_E22
  //   
  reg  signed [17:0] output_register; // sfix18_E22

  // Block Statements
  //   ------------------ CE Output Generation ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 6'b000000;
      end
      else begin
        if (clk_enable == 1'b1) begin
          if (cur_count == 6'b111111) begin
            cur_count <= 6'b000000;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  assign  phase_1 = (cur_count == 6'b000001 && clk_enable == 1'b1)? 1 : 0;

  always @( posedge clk or posedge reset)
    begin: ce_delay
      if (reset == 1'b1) begin
        int_delay_pipe[0] <= 1'b0;
        int_delay_pipe[1] <= 1'b0;
        int_delay_pipe[2] <= 1'b0;
      end
      else begin
        if (phase_1 == 1'b1) begin
        int_delay_pipe[0] <= clk_enable;
        int_delay_pipe[1] <= int_delay_pipe[0];
        int_delay_pipe[2] <= int_delay_pipe[1];
        end
      end
    end // ce_delay

    assign ce_delayline = int_delay_pipe[2];
  assign ce_gated =  ce_delayline & phase_1;

  //   ------------------ CE Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output_register
      if (reset == 1'b1) begin
        ce_out_reg <= 1'b0;
      end
      else begin
          ce_out_reg <= ce_gated;
      end
    end // ce_output_register

  //   ------------------ Input Register ------------------

  always @ (posedge clk or posedge reset)
    begin: input_reg_process
      if (reset == 1'b1) begin
        input_register <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          input_register <= filter_in;
        end
      end
    end // input_reg_process

  //   ------------------ Section # 1 : Integrator ------------------

  assign section_in1 = input_register;

  assign section_cast1 = $signed({{24{section_in1[15]}}, section_in1});

  assign add_cast = section_cast1;
  assign add_cast_1 = section_out1;
  assign add_temp = add_cast + add_cast_1;
  assign sum1 = add_temp[39:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section1
      if (reset == 1'b1) begin
        section_out1 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out1 <= sum1;
        end
      end
    end // integrator_delay_section1

  //   ------------------ Section # 2 : Integrator ------------------

  assign section_in2 = section_out1;

  assign section_cast2 = section_in2[39:5];

  assign add_cast_2 = section_cast2;
  assign add_cast_3 = section_out2;
  assign add_temp_1 = add_cast_2 + add_cast_3;
  assign sum2 = add_temp_1[34:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section2
      if (reset == 1'b1) begin
        section_out2 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out2 <= sum2;
        end
      end
    end // integrator_delay_section2

  //   ------------------ Section # 3 : Integrator ------------------

  assign section_in3 = section_out2;

  assign section_cast3 = section_in3[34:5];

  assign add_cast_4 = section_cast3;
  assign add_cast_5 = section_out3;
  assign add_temp_2 = add_cast_4 + add_cast_5;
  assign sum3 = add_temp_2[29:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section3
      if (reset == 1'b1) begin
        section_out3 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out3 <= sum3;
        end
      end
    end // integrator_delay_section3

  //   ------------------ Section # 4 : Integrator ------------------

  assign section_in4 = section_out3;

  assign section_cast4 = section_in4[29:5];

  assign add_cast_6 = section_cast4;
  assign add_cast_7 = section_out4;
  assign add_temp_3 = add_cast_6 + add_cast_7;
  assign sum4 = add_temp_3[24:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section4
      if (reset == 1'b1) begin
        section_out4 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out4 <= sum4;
        end
      end
    end // integrator_delay_section4

  //   ------------------ Section # 5 : Comb ------------------

  assign section_in5 = section_out4;

  assign section_cast5 = section_in5[24:2];

  assign sub_cast = section_cast5;
  assign sub_cast_1 = diff1;
  assign sub_temp = sub_cast - sub_cast_1;
  assign section_out5 = sub_temp[22:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section5
      if (reset == 1'b1) begin
        diff1 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff1 <= section_cast5;
        end
      end
    end // comb_delay_section5

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section5
      if (reset == 1'b1) begin
        cic_pipeline5 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline5 <= section_out5;
        end
      end
    end // cic_pipeline_process_section5

  //   ------------------ Section # 6 : Comb ------------------

  assign section_in6 = cic_pipeline5;

  assign section_cast6 = section_in6[22:1];

  assign sub_cast_2 = section_cast6;
  assign sub_cast_3 = diff2;
  assign sub_temp_1 = sub_cast_2 - sub_cast_3;
  assign section_out6 = sub_temp_1[21:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section6
      if (reset == 1'b1) begin
        diff2 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff2 <= section_cast6;
        end
      end
    end // comb_delay_section6

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section6
      if (reset == 1'b1) begin
        cic_pipeline6 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline6 <= section_out6;
        end
      end
    end // cic_pipeline_process_section6

  //   ------------------ Section # 7 : Comb ------------------

  assign section_in7 = cic_pipeline6;

  assign section_cast7 = section_in7[21:1];

  assign sub_cast_4 = section_cast7;
  assign sub_cast_5 = diff3;
  assign sub_temp_2 = sub_cast_4 - sub_cast_5;
  assign section_out7 = sub_temp_2[20:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section7
      if (reset == 1'b1) begin
        diff3 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff3 <= section_cast7;
        end
      end
    end // comb_delay_section7

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section7
      if (reset == 1'b1) begin
        cic_pipeline7 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline7 <= section_out7;
        end
      end
    end // cic_pipeline_process_section7

  //   ------------------ Section # 8 : Comb ------------------

  assign section_in8 = cic_pipeline7;

  assign section_cast8 = section_in8[20:1];

  assign sub_cast_6 = section_cast8;
  assign sub_cast_7 = diff4;
  assign sub_temp_3 = sub_cast_6 - sub_cast_7;
  assign section_out8 = sub_temp_3[19:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section8
      if (reset == 1'b1) begin
        diff4 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff4 <= section_cast8;
        end
      end
    end // comb_delay_section8

  assign output_typeconvert = section_out8[19:2];

  //   ------------------ Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: output_reg_process
      if (reset == 1'b1) begin
        output_register <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          output_register <= output_typeconvert;
        end
      end
    end // output_reg_process

  // Assignment Statements
  assign ce_out = ce_out_reg;
  assign filter_out = output_register;
endmodule  // CIC_R64_M1_N4
